m4_dnl# FOR MMSS VERSION 0.07 ONWARDS:
m4_dnl# Having learnt the hard way just how mind bogglingly SLOW
m4_dnl# M4 can be, I'm now only using it to expand macros included
m4_dnl# inline in the blocks of text. Everything else that the m4
m4_dnl# macros here *used to* do will now be done in a saner language,
m4_dnl# namely *perl*.
m4_dnl#
m4_dnl# Macros implemented here:
m4_dnl# MMSS_image(image's relative URL)
m4_dnl#   places an inline image, with size tags, and maintains a
m4_dnl#   reference count to that image; when the reference count is
m4_dnl#   0, no pages refer to the image, so it can be deleted from
m4_dnl#   the site. When an image's reference count goes above 0, it
m4_dnl#   needs to be uploaded if it isn't already.
m4_dnl# MMSS_localfile(label, relative URL)
m4_dnl#   places a link ("anchor") to a file in the MMSS site tree,
m4_dnl#   and maintains a reference count to that file. If the count
m4_dnl#   is non-zero, the file will be uploaded to/ kept on the site.
m4_dnl#   if it drops to zero, it will be deleted from the site (but not
m4_dnl#   from the local copy of the document tree). You should *not*
m4_dnl#   use this to refer to HTML pages generated by MMSS- these do not
m4_dnl#   need a reference count, and MMSS will get confused. To make plain
m4_dnl#   links to such pages, just use <a href> tags like in plain HTML.
m4_dnl#   You *can* also use this macro to link to HTML pages you created
m4_dnl#   yourself, if they're part of the MMSS site tree.
m4_dnl# MMSS_imagelocallink(image's relative URL, relative URL)
m4_dnl#   like MMSS_image, but is also a link to a local resource
m4_dnl#   and maintains a refcount for that too. NB: Don't use this
m4_dnl#   to link to MMSS generated HTML files, as those don't want
m4_dnl#   to be handled by the reference count system...
m4_dnl# MMSS_imageotherlink(image's relative URL, general URL)
m4_dnl#   like MMSS_imagelocallink, but the URL linked to isn't
m4_dnl#   managed by MMSS's reference counts, etc. NB: This can
m4_dnl#   still be a *relative* URL, but MMSS will not concern itself
m4_dnl#   with whether the file is on the site or not. If you want to
m4_dnl#   use images to link to other pages of your MMSS-managed site,
m4_dnl#   you should use this macro.
m4_dnl#



m4_dnl# change the quote types to deal with the 's in HTML
m4_dnl# plus the punctuation in normal text...
m4_dnl# note that we now run m4 with -P to prepend built-ins with m4_.
m4_dnl# this is because m4 was too cretinous to realise that the word
m4_dnl# "format" was not intended as a macro, even though it had no
m4_dnl# parentheses after it.
m4_changequote([q[, ]q])m4_dnl#eatme
m4_dnl#don't bother with comments, just use dnl instead
m4_define(MMSS_addref,[q[m4_esyscmd(echo $1 >>$page.res)]q])m4_dnl#
m4_dnl# After processing this page, do cat $page.res|sort|uniq >$page.res;
m4_dnl# then go through the resources listed, and add backreferences to their
m4_dnl# $item.ref file.
m4_dnl
m4_define(MMSS_image,[q[<img src="$1" m4_esyscmd(mmss_getimgsize $1)>MMSS_addref($1)]q])m4_dnl#
m4_define(MMSS_localfile,[q[<a href="$2">$1</a>MMSS_addref($2)]q])m4_dnl#
m4_define(MMSS_imagelocallink,[q[<a href="$2"><img src="$1" m4_esyscmd(mmss_getimgsize $1)></a>MMSS_addref($1)MMSS_addref($2)]q])m4_dnl#
m4_define(MMSS_imageotherlink,[q[<a href="$2"><img src="$1" m4_esyscmd(mmss_getimgsize $1)></a>MMSS_addref($1)]q])m4_dnl#
m4_dnl#
m4_dnl# That should be all we need now :)



m4_dnl#
m4_dnl# make our macros, these are OBSOLETE!
m4_define(MMSS_setroot,[q[m4_define(MMSS_rootdir,$1)]q])m4_dnl#eatme
m4_dnl#was that totally pointless? hmm, no, it saves *a bit*.
m4_define(MMSS_setpage,[q[m4_define(MMSS_page,$1)]q])m4_dnl#eatme
m4_define(MMSS_setsect,[q[m4_define(MMSS_sect,$1)]q])m4_dnl#eatme
m4_dnl#
m4_define(MMSS_getcf,[q[m4_esyscmd(clipcode MMSS_rootdir/site.cfg $1|mmss_enquote 1)]q])m4_dnl#changed 30th Apr 2004, to use mmss_enquote 1 for sanity
m4_define(MMSS_getquotcf,[q[m4_esyscmd(clipcode MMSS_rootdir/site.cfg $1|mmss_enquote 2)]q])m4_dnl# added 30th Apr 2004, for use of list based macros
m4_dnl# FOR loop constructs. Universal enough to put here, 30 Apr 2004
m4_define(_MMSS_forloop,
  [q[$4[q[]q]m4_ifelse($1,[q[$3]q], ,
    [q[m4_define([q[$1]q],m4_incr($1))_MMSS_forloop([q[$1]q],[q[$2]q],[q[$3]q],[q[$4]q])]q])]q])m4_dnl#pardon?
m4_define(MMSS_loop,[q[m4_pushdef([q[$1]q], [q[$2]q])_MMSS_forloop([q[$1]q],[q[$2]q],[q[$3]q],[q[$4]q])m4_popdef([q[$1]q])]q])m4_dnl#eek! From m4 info page
m4_dnl# end FOR loop code
m4_dnl#
m4_dnl#
m4_dnl# Start of HTMLish macros
m4_define(MMSS_startpage,[q[<HTML>
MMSS_setsect($2)m4_dnl#eatme
MMSS_setpage($3)m4_dnl#eatme
MMSS_setroot($4)m4_dnl#eatme
<HEAD><TITLE>$1</TITLE></HEAD>
<BODY bgcolor=MMSS_getcf(bodybg) text='#000000'><!--temporary BG colour -->
<CENTER><IMG src=MMSS_getcf(sitelogo)>
</CENTER><BR>]q])m4_dnl#eatme
m4_define(MMSS_endpage,
[q[<!-- a small horizontal spacer --><table border='0' width='100%' cellpadding='0' cellspacing='0'><tr><td
height='10'></td></tr></table>m4_dnl#that's to end the mainboxes column
<!--  a small vertical spacer --></td><td width='20'></td>
<!-- The right column (N/A) --><td valign='top' align='center'></td>
<!-- end of the main layout table --></tr></table>
<!-- Just some HRs at the bottom --><br><center><hr size='2'><font color=MMSS_getcf(bodytext)>These
pages created and maintained with
<a href="http://www.angelfire.com/super2/duologue/software/mmss.html">MMSS</a>
(Make My Static Site)</font><hr size='2'></center>
</BODY>
</HTML>]q])m4_dnl#eatme
m4_dnl#
m4_define(MMSS_anchline,[q[<tr><td></td><td><a href=$1>$2</a></td></tr>]q])m4_dnl#defineeatme
m4_dnl# a line of a sidebox, containing a URL($1) and name($2)
m4_dnl#
m4_dnl#
m4_define(MMSS_navbar, [q[<!-- Main page layout table -->
<table width='100%' border='0' cellspacing='0' cellpadding='0'>
<tr><td valign='top' width='150' align='center'>
<!-- Start of Sidebar bit -->MMSS_sidebox([q[Site Map]q],[q[site.nav]q])m4_dnl#eatme
<!-- a small horizontal spacer --><br>
m4_dnl# ideally, I'd have this deal with variable numbers of
m4_dnl# arguments: 0 args means no further nav boxes;
m4_dnl# 1 arg means page nav box only,
m4_dnl# 2 args means section nav box only,
m4_dnl# 3 args means *all* nav boxes.
m4_dnl# If we have no section nav box, we must pass a different
m4_dnl# arg to the page nav box (as there will be no $3).
MMSS_sidebox([q[Navigate $1]q],MMSS_sect.nav)m4_dnl#eatme
<!-- a small horizontal spacer --><br>MMSS_sidebox([q[This Page]q],MMSS_page.pnav)m4_dnl#eatme
<!-- a small horizontal spacer --><br>
m4_dnl#
m4_dnl#include(counter.input)dnl#eatme
m4_dnl# No, I'd like to stick the counter in a little box like the nav boxes!
MMSS_sidebox([q[Lovely Counter]q],[q[counter.input]q])m4_dnl#eatme
<!-- a small horizontal spacer --><table border='0' width='100%' cellpadding='0' cellspacing='0'><tr><td
height='10'></td></tr></table>
m4_dnl# Now end of navbar
</td>m4_dnl# follow this with MMSS_vspacer and then MMSS_mainblock
m4_dnl# actually, lets put in the vspacer here.
<td width='20'></td><td valign='top'>m4_dnl#now just put in mainboxes after.
]q])
m4_dnl# Args: $1-Section name $2-Section navfile $3-Page navfile
m4_dnl#
m4_dnl#
m4_dnl#
m4_dnl# Eventually, MMSS_sidebox will take the MMSS_newsidebox behaviour
m4_define(MMSS_sidebox, MMSS_newsidebox($1,[q[m4_include($2)]q]))m4_dnl#eatme
m4_dnl# MMSS_newsidebox now doesn't include external files, you have
m4_dnl# to do that explicitly. New definition of MMSS_sidebox implements this.
m4_define(MMSS_newsidebox, [q[<table border='0' cellspacing='0' cellpadding='0' width='140' bgcolor='#000000'><tr><td>
<table width='100%' border='0' cellspacing='1' cellpadding='3'>
<tr><td colspan='1' bgcolor=MMSS_getcf(boxheadbg)>
m4_dnl# titlebox
m4_dnl# Put the title
$1[q[]q]m4_dnl#eatme
m4_dnl# arg 1 is the title for the box

</td></tr>
<tr><td bgcolor=MMSS_getcf(boxbg)>
    <table border='0' cellspacing='0' cellpadding='5'><tr><td>
        <table border='0' cellspacing='0' cellpadding='2'>

m4_dnl# put in the list of links (which must each use
m4_dnl# a special macro to stick them on their own line)
m4_dnl# Nope, now we put in arbitrary text, which will probably
m4_dnl# be links.
m4_dnl#   m4_i nclude((arg) 2)m4_dnl#eatme
$2
m4_dnl# arg 2 is the list of link lines to put in the box

        </table>
        </td></tr>
       </table>
</td></tr></table>
</td></tr></table>]q])m4_dnl
m4_dnl#
m4_dnl#
m4_dnl#
m4_dnl# Now, the Mainbox
m4_define(MMSS_mainbox, [q[<a name='$2'></a>
<table border='0' cellpadding='0' cellspacing='0'
align='center' bgcolor='#000000' width='100%'><tr><td>
<table border='0' cellpadding='5' cellspacing='1' width='100%'>
<tr>
  <td bgcolor=MMSS_getcf(boxheadbg)>
    <h4>$1</h4>
    $3
  </td>
</tr><tr>
  <td bgcolor=MMSS_getcf(boxbg)>
    <table border='0' cellspacing='0' cellpadding='5'>
    <tr>
     <td>
        m4_dnl#eatme
m4_dnl#  used to include ((arg)2,(arg)3.input), but putting pagename got
m4_dnl#  messy. Hey, the (arg) symbols get interpreted even in comments!
m4_dnl#  so when they expand to something with a newline... kapow!
m4_dnl#  the stuff after the newline is no longer commented... Ow!
m4_include(MMSS_page.$2.input)
        m4_dnl#eatme
     </td>
    </tr></table>
  </td>
</tr>
</table>
</td></tr></table>
<!-- small spacer -->
<br>]q])m4_dnl#eatme
m4_dnl# note that the <br> will be put even after the last one. Who cares?
m4_dnl#
